"""Extend Resource Version status and add change to internal uid

Revision ID: 1bde8ed4ca83
Revises: 410efa47f94c
Create Date: 2024-01-22 17:53:16.083553

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = "1bde8ed4ca83"
down_revision = "410efa47f94c"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("bucketpermission_ibfk_2", "bucketpermission", type_="foreignkey")
    op.drop_column("bucketpermission", "user_id")
    op.drop_constraint("workflow_execution_ibfk_1", "workflow_execution", type_="foreignkey")
    op.drop_constraint("workflow_ibfk_1", "workflow", type_="foreignkey")
    op.drop_constraint("bucket_ibfk_1", "bucket", type_="foreignkey")
    op.drop_constraint("resource_ibfk_1", "resource", type_="foreignkey")
    op.drop_constraint("bucketpermission_ibfk_1", "bucketpermission", type_="foreignkey")
    op.drop_column("workflow_execution", "user_id")

    op.alter_column(
        "user", "uid", existing_type=mysql.VARCHAR(length=64), type_=sa.BINARY(length=16), existing_nullable=False
    )
    op.alter_column(
        "bucket", "owner_id", existing_type=mysql.VARCHAR(length=64), type_=sa.BINARY(length=16), existing_nullable=True
    )
    op.alter_column(
        "resource",
        "maintainer_id",
        existing_type=mysql.VARCHAR(length=64),
        type_=sa.BINARY(length=16),
        existing_nullable=True,
    )
    op.alter_column(
        "workflow",
        "developer_id",
        existing_type=mysql.VARCHAR(length=64),
        type_=sa.BINARY(length=16),
        existing_nullable=True,
    )
    op.add_column("workflow_execution", sa.Column("executor_id", sa.BINARY(length=16), nullable=False))
    op.add_column("bucketpermission", sa.Column("uid", sa.BINARY(length=16), nullable=False))
    op.get_bind().execute(
        sa.sql.text("ALTER TABLE bucketpermission drop primary key, add primary key(uid, bucket_name);")
    )
    op.create_foreign_key(
        "bucketpermission_ibfk_1", "bucketpermission", "bucket", ["bucket_name"], ["name"], ondelete="CASCADE"
    )
    op.create_foreign_key(None, "workflow", "user", ["developer_id"], ["uid"], ondelete="SET NULL")
    op.create_foreign_key(None, "bucket", "user", ["owner_id"], ["uid"], ondelete="SET NULL")
    op.create_foreign_key(None, "resource", "user", ["maintainer_id"], ["uid"], ondelete="SET NULL")
    op.create_foreign_key(None, "workflow_execution", "user", ["executor_id"], ["uid"], ondelete="CASCADE")
    op.create_foreign_key(None, "bucketpermission", "user", ["uid"], ["uid"], ondelete="CASCADE")

    op.add_column("resource_version", sa.Column("sync_finished_timestamp", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("sync_slurm_job_id", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("cluster_deleted_timestamp", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("cluster_delete_slurm_job_id", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("s3_deleted_timestamp", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("set_latest_timestamp", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("set_latest_slurm_job_id", sa.Integer(), nullable=True))
    op.add_column("resource_version", sa.Column("remove_latest_timestamp", sa.Integer(), nullable=True))
    op.add_column("user", sa.Column("lifescience_id", sa.String(length=64), nullable=True))
    op.add_column("user", sa.Column("email", sa.String(length=256), nullable=True))
    op.add_column("user", sa.Column("aruna_token", sa.String(length=128), nullable=True))

    op.create_index(op.f("ix_user_lifescience_id"), "user", ["lifescience_id"], unique=True)
    op.add_column("workflow_execution", sa.Column("cpu_hours", sa.Float(), server_default=sa.text("0"), nullable=False))

    op.alter_column(
        "resource_version",
        "status",
        existing_type=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "SYNC_REQUESTED",
            "SYNCHRONIZING",
            "SYNCHRONIZED",
            "LATEST",
            "DENIED",
            "CLUSTER_DELETED",
            "S3_DELETED",
        ),
        type_=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "SYNC_REQUESTED",
            "DENIED",
            "SYNCHRONIZING",
            "SYNC_ERROR",
            "SYNCHRONIZED",
            "SETTING_LATEST",
            "LATEST",
            "CLUSTER_DELETING",
            "CLUSTER_DELETE_ERROR",
            "CLUSTER_DELETED",
            "S3_DELETING",
            "S3_DELETE_ERROR",
            "S3_DELETED",
        ),
        existing_nullable=False,
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("workflow_execution_ibfk_3", "workflow_execution", type_="foreignkey")
    op.drop_constraint("bucketpermission_ibfk_2", "bucketpermission", type_="foreignkey")
    op.drop_constraint("bucketpermission_ibfk_1", "bucketpermission", type_="foreignkey")
    op.drop_column("bucketpermission", "uid")
    op.drop_constraint("workflow_ibfk_1", "workflow", type_="foreignkey")
    op.drop_constraint("bucket_ibfk_1", "bucket", type_="foreignkey")
    op.drop_constraint("resource_ibfk_1", "resource", type_="foreignkey")
    op.drop_column("workflow_execution", "executor_id")

    op.alter_column(
        "user", "uid", existing_type=sa.BINARY(length=16), type_=mysql.VARCHAR(length=64), existing_nullable=False
    )

    op.add_column("workflow_execution", sa.Column("user_id", mysql.VARCHAR(length=64), nullable=False))
    op.create_foreign_key(
        "workflow_execution_ibfk_1", "workflow_execution", "user", ["user_id"], ["uid"], ondelete="CASCADE"
    )
    op.drop_column("workflow_execution", "cpu_hours")

    op.alter_column(
        "workflow",
        "developer_id",
        existing_type=sa.BINARY(length=16),
        type_=mysql.VARCHAR(length=64),
        existing_nullable=True,
    )
    op.alter_column(
        "resource",
        "maintainer_id",
        existing_type=sa.BINARY(length=16),
        type_=mysql.VARCHAR(length=64),
        existing_nullable=True,
    )
    op.alter_column(
        "bucket", "owner_id", existing_type=sa.BINARY(length=16), type_=mysql.VARCHAR(length=64), existing_nullable=True
    )
    op.add_column("bucketpermission", sa.Column("user_id", mysql.VARCHAR(length=64), nullable=False))

    op.drop_column("user", "aruna_token")
    op.drop_column("user", "email")
    op.drop_index(op.f("ix_user_lifescience_id"), table_name="user")
    op.drop_column("user", "lifescience_id")
    op.drop_column("resource_version", "remove_latest_timestamp")
    op.drop_column("resource_version", "set_latest_slurm_job_id")
    op.drop_column("resource_version", "set_latest_timestamp")
    op.drop_column("resource_version", "s3_deleted_timestamp")
    op.drop_column("resource_version", "cluster_delete_slurm_job_id")
    op.drop_column("resource_version", "cluster_deleted_timestamp")
    op.drop_column("resource_version", "sync_slurm_job_id")
    op.drop_column("resource_version", "sync_finished_timestamp")

    op.get_bind().execute(
        sa.sql.text("ALTER TABLE bucketpermission drop primary key, add primary key(user_id, bucket_name);")
    )

    op.create_foreign_key(
        "bucketpermission_ibfk_2", "bucketpermission", "user", ["user_id"], ["uid"], ondelete="CASCADE"
    )
    op.create_foreign_key(
        "bucketpermission_ibfk_1", "bucketpermission", "bucket", ["bucket_name"], ["name"], ondelete="CASCADE"
    )

    op.alter_column(
        "resource_version",
        "status",
        existing_type=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "SYNC_REQUESTED",
            "DENIED",
            "SYNCHRONIZING",
            "SYNC_ERROR",
            "SYNCHRONIZED",
            "SETTING_LATEST",
            "LATEST",
            "CLUSTER_DELETING",
            "CLUSTER_DELETE_ERROR",
            "CLUSTER_DELETED",
            "S3_DELETING",
            "S3_DELETE_ERROR",
            "S3_DELETED",
        ),
        type_=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "SYNC_REQUESTED",
            "SYNCHRONIZING",
            "SYNCHRONIZED",
            "LATEST",
            "DENIED",
            "CLUSTER_DELETED",
            "S3_DELETED",
        ),
        existing_nullable=False,
    )
    # ### end Alembic commands ###
